#include <iostream>
#include <cassert>

using namespace std;

//    nibble (4 )   
char nibble_to_hex(uint8_t i) {
    //     
    char digits[] = "0123456789abcdef";

    //    
    assert(0x0 <= i && i <= 0xf);

    //    nibble   digits
    return digits[i];
}

//          
void print_in_hex(uint8_t byte) {
    //    
    cout << "Hex: " << nibble_to_hex(byte >> 4) << nibble_to_hex(byte & 0xf) << endl;

    //    
    cout << "Binary: ";
    for (int i = 7; i >= 0; --i) {
        cout << ((byte >> i) & 1);
    }
    cout << endl;
}

const uint8_t* as_bytes(const void* data) {
    return reinterpret_cast<const uint8_t*>(data);
};

void print_in_hex(const void* data, size_t size) {
    const uint8_t* bytes = as_bytes(data);
    for (size_t i = 0; i < size; i++) {
        print_in_hex(bytes[i]);

        //   :   ,  16   .
        if ((i + 1) % 16 == 0) {
            cout << '\n';
        } else {
            cout << ' ';
        }
    }
    cout << endl;
}


int main() {


    //   nibble_to_hex
    //for (int i = 0; i <= 0xf; ++i) {
        //assert(nibble_to_hex(i) == nibble_to_hex(i));
    //}

    assert(nibble_to_hex(0x0) == '0');
    assert(nibble_to_hex(0x1) == '1');
    assert(nibble_to_hex(0x2) == '2');
    assert(nibble_to_hex(0x3) == '3');
    assert(nibble_to_hex(0x4) == '4');
    assert(nibble_to_hex(0x5) == '5');
    assert(nibble_to_hex(0x6) == '6');
    assert(nibble_to_hex(0x7) == '7');
    assert(nibble_to_hex(0x8) == '8');
    assert(nibble_to_hex(0x9) == '9');
    assert(nibble_to_hex(0xa) == 'a');
    assert(nibble_to_hex(0xb) == 'b');
    assert(nibble_to_hex(0xc) == 'c');
    assert(nibble_to_hex(0xd) == 'd');
    assert(nibble_to_hex(0xe) == 'e');
    assert(nibble_to_hex(0xf) == 'f');

    //       
    //uint8_t test_byte = 0x2f;
    //uint8_t test_byte = 0x0;
    //uint8_t test_byte = 0xab;
    //uint8_t test_byte = 0xff;

    uint8_t u8 = 0x42;
    uint16_t u16 = 0x42;
    uint32_t u32 = 0x42;

    std::cout << "u8 bytes: ";
    print_in_hex(&u8, sizeof(u8));
    std::cout << '\n';

    std::cout << "u16 bytes: ";
    print_in_hex(&u16, sizeof(u16));
    std::cout << '\n';

    std::cout << "u32 bytes: ";
    print_in_hex(&u32, sizeof(u32));
    std::cout << '\n';

    return 0;
}


